<?php
/**
 * Application level Controller
 *
 * This file is application-wide controller file. You can put all
 * application-wide controller-related methods here.
 *
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link          http://cakephp.org CakePHP(tm) Project
 * @package       app.Controller
 * @since         CakePHP(tm) v 0.2.9
 * @license       http://www.opensource.org/licenses/mit-license.php MIT License
 */

App::uses('Controller', 'Controller');

/**
 * Application Controller
 *
 * Add your application-wide methods in the class below, your controllers
 * will inherit them.
 *
 * @package		app.Controller
 * @link		http://book.cakephp.org/2.0/en/controllers.html#the-app-controller
 */
class AppController extends Controller {
		var $components = array('Auth');
		var $uses=array('Group');

	public function beforeFilter(){
		$hak_akses=$this->Auth->user('hak_akses');
		$group=$this->Group->find('first',array('conditions'=>array('Group.nama'=>$hak_akses)));
		if ($group) {
			if (($this->action=="add")&&($group['Group']['tambah_data']!="Ya")) {
				$this->redirect(array('controller'=>'Pages', 'action'=>'deny'));
			}
			if (($this->action=="update")&&($group['Group']['update_data']!="Ya")) {
				$this->redirect(array('controller'=>'Pages', 'action'=>'deny'));
			}
			if (($this->action=="delete")&&($group['Group']['delete_data']!="Ya")) {
				$this->redirect(array('controller'=>'Pages', 'action'=>'deny'));
			}
		}
	}

	public function ubah($masukan) {
			$tanggal=explode(' ',$masukan);
			$hari=$tanggal[0]; 
			switch ($tanggal[1]) {
				case "Januari" 		: $text = "01"; break;
				case "Februari" 	: $text = "02"; break;
				case "Maret" 		: $text = "03"; break;
				case "April" 		: $text = "04"; break;
				case "Mei" 			: $text = "05"; break;
				case "Juni" 		: $text = "06"; break;
				case "Juli" 		: $text = "07"; break;
				case "Agustus" 		: $text = "08"; break;
				case "September" 	: $text = "09"; break;
				case "Oktober" 		: $text = "10"; break;
				case "November" 	: $text = "11"; break;
				case "Desember" 	: $text = "12"; break;
				default : break;
			}
			$tahun=$tanggal[2];
			return $hari.' '.$text.' '.$tahun;
	}

	public function balik($masukan) {
			$tanggal=strtotime($masukan);
			$hari=intval(date("d",$tanggal)); 
			switch (date("m",$tanggal)) {
				case "01" : $text = "Januari"; break;
				case "02" : $text = "Februari"; break;
				case "03" : $text = "Maret"; break;
				case "04" : $text = "April"; break;
				case "05" : $text = "Mei"; break;
				case "06" : $text = "Juni"; break;
				case "07" : $text = "Juli"; break;
				case "08" : $text = "Agustus"; break;
				case "09" : $text = "September"; break;
				case "10" : $text = "Oktober"; break;
				case "11" : $text = "November"; break;
				case "12" : $text = "Desember"; break;
				default : break;
			}
			$tahun=date("Y",$tanggal);
			return $hari.' '.$text.' '.$tahun;
	}

	public function earlierdate($date1, $date2) {
		$yeardate1=intval(substr($date1,0,4));
		$monthdate1=intval(substr($date1,5,2));
		$daydate1=intval(substr($date1,8,2));
		$yeardate2=intval(substr($date2,0,4));
		$monthdate2=intval(substr($date2,5,2));
		$daydate2=intval(substr($date2,8,2));
		if ($yeardate1<$yeardate2) {
			return true;
		} else if ($yeardate1>$yeardate2) {
			return false;
		} else {
			if ($monthdate1<$monthdate2) {
				return true;
			} else if ($monthdate1>$monthdate2) {
				return false;
			} else {
				if ($daydate1<=$daydate2) {
					return true;
				} else if ($daydate1>$daydate2) {
					return false;
				}
			}
		}
	}
	
		function rupiah($masukan) {
			if ($masukan) {$uang=floatval($masukan);} else {$uang=0;}
			if ($uang<0) {$negatif=true;} else {$negatif=false;}
			$uang=abs($uang);
			$uang=number_format($uang,2,",",".");
			if ($negatif) {
				return "-Rp".$uang;
			} else {
				return "Rp".$uang;
			}
/*			$bulat=floor($uang);
			$desimal=($uang-$bulat).toFixed(2);
			$x=strlen($uang);
			$sisa=$x%3;
			$pengulangan=($x-$sisa)/3;
			$hasil='Rp. '.substr($uang,0,$sisa);
			for ($y=0; $y<$pengulangan; $y++) {
				if (($y==0)&&($sisa==0)) $hasil=$hasil.substr($uang,$sisa+$y*3,3); else
					$hasil=$hasil.".".substr($uang,$sisa+$y*3,3);
			}
			$hasil=$hasil.',00';
			return $hasil;*/
		}

}