<?php
/**
* 
*/
class JournalsController extends AppController{
	var $name = 'Journals';
	var $helpers = array('Html', 'Form');
	var $uses = array('Journal','Account');
	var $layout = 'mainlayout';

	public function beforeFilter(){
		parent::beforeFilter();
	}

	public function ubahhasil($masukan) {
			$tanggal=strtotime($masukan);
			$hari=intval(date("d",$tanggal)); 
			switch (date("m",$tanggal)) {
				case "01" : $text = "Januari"; break;
				case "02" : $text = "Februari"; break;
				case "03" : $text = "Maret"; break;
				case "04" : $text = "April"; break;
				case "05" : $text = "Mei"; break;
				case "06" : $text = "Juni"; break;
				case "07" : $text = "Juli"; break;
				case "08" : $text = "Agustus"; break;
				case "09" : $text = "September"; break;
				case "10" : $text = "Oktober"; break;
				case "11" : $text = "November"; break;
				case "12" : $text = "Desember"; break;
				default : break;
			}
			$tahun=date("Y",$tanggal);
			return $hari.' '.$text.' '.$tahun;
	}

	public function earlierdate($date1, $date2) {
		$yeardate1=intval(substr($date1,0,4));
		$monthdate1=intval(substr($date1,5,2));
		$daydate1=intval(substr($date1,8,2));
		$yeardate2=intval(substr($date2,0,4));
		$monthdate2=intval(substr($date2,5,2));
		$daydate2=intval(substr($date2,8,2));
		if ($yeardate1<$yeardate2) {
			return true;
		} else if ($yeardate1>$yeardate2) {
			return false;
		} else {
			if ($monthdate1<$monthdate2) {
				return true;
			} else if ($monthdate1>$monthdate2) {
				return false;
			} else {
				if ($daydate1<=$daydate2) {
					return true;
				} else if ($daydate1>$daydate2) {
					return false;
				}
			}
		}
	}

	public function index(){
		if (isset($_GET['halaman'])) {$halaman=$_GET['halaman'];} else {$halaman=0;}
		if (isset($_GET['tgl_awal'])) {$tglawal=$_GET['tgl_awal'];} else {$tglawal=null;}
		if (isset($_GET['tgl_akhir'])) {$tglakhir=$_GET['tgl_akhir'];} else {$tglakhir=null;}
		if (isset($_GET['akun'])) {$akun=$_GET['akun'];} else {$akun=null;}
		if (isset($_GET['search'])) {$search=$_GET['search'];} else {$search=null;}
		$data=$this->Journal->find('all');
		$sumber=array();
		$journals=array();
		if (($tglawal==null)&&($tglakhir==null)&&($akun==null)&&($search==null)) {
			$sumber=$data;
		} else {
			$y=0;
			foreach ($data as $record) {
				$tanggal=$record['Journal']['tanggal'];
				$kondisi1=$this->earlierdate($tglawal,$tanggal)||($tglawal==null);
				$kondisi2=$this->earlierdate($tanggal,$tglakhir)||($tglakhir==null);
				$kondisiakun=($record['Journal']['akun']==$akun)||($akun==null);
				$text=false;
				if ($search) {
					$kondisi3=(strpos(' '.strtoupper($this->ubahhasil($record['Journal']['tanggal'])),strtoupper($search))>0); 
					$kondisi4=(strpos(' '.strtoupper($record['Journal']['akun']),strtoupper($search))>0);
					$kondisi5=(strpos(' '.strtoupper($record['Journal']['deskripsi']),strtoupper($search))>0);
					$kondisi6=(strpos(' '.strtoupper($record['Journal']['debit']),strtoupper($search))>0);
					$kondisi7=(strpos(' '.strtoupper($record['Journal']['kredit']),strtoupper($search))>0);
					if ($kondisi3||$kondisi4||$kondisi5||$kondisi6||$kondisi7) {
						$text=true;
					}
				} else $text=true;
				if ($kondisi1&&$kondisi2&&$kondisiakun&&$text) {
					$sumber[$y]=$record;
					$y++;
				}
			}
		}
		$jumlahsumber=count($sumber);
		$jumlahhalaman=ceil(count($sumber)/10);
		if ($jumlahhalaman==0) {
			$jumlahhalaman=1;
		}
		if ($halaman==0) {
			$halaman=$jumlahhalaman;
		}
		for ($x=0; $x<10; $x++) {
			$indeks=($halaman-1)*10+$x;
			if ($indeks<$jumlahsumber) {
				$journals[$x]=$sumber[$indeks];
			} else break;
		}
		foreach ($journals as $id=>$journal) {
			$journals[$id]['Journal']['tanggal']=$this->ubahhasil($journals[$id]['Journal']['tanggal']);
		}
		$this->set('journals',$journals);		        
		$this->set('jumlahdata',count($sumber));		        
		$this->set('halaman',$halaman);		        
		$this->set('jumlahhalaman',$jumlahhalaman);		        
		$this->set('tglawal',$tglawal);		        
		$this->set('tglakhir',$tglakhir);		        
		$this->set('akun',$akun);		        
		$this->set('search',$search);		        
		$this->set('accounts',$this->Account->find('all'));		        
	}

	public function add(){
		if(!empty($this->data)){
			$data=$this->data;
			$account=$this->Account->find('first',array('conditions'=>array('Account.nama'=>$data['Journal']['akun'])));
			if ($account['Account']['tipe']=='Debit') {
				$data['Journal']['debit']=$data['Journal']['jumlah'];
			} else {
				$data['Journal']['kredit']=$data['Journal']['jumlah'];
			}
			$this->Journal->save($data);
			$this->redirect(array('controller'=>'Journals', 'action'=>'index'));
		}
		$this->set('accounts',$this->Account->find('all'));		        
	}

	public function edit($id=null){
		$this->Journal->id=$id;
		if(!empty($this->data)){
			$data=$this->data;
			$account=$this->Account->find('first',array('conditions'=>array('Account.nama'=>$data['Journal']['akun'])));
			if ($account['Account']['tipe']=='Debit') {
				$data['Journal']['debit']=$data['Journal']['jumlah'];
				$data['Journal']['kredit']='';
			} else {
				$data['Journal']['debit']='';
				$data['Journal']['kredit']=$data['Journal']['jumlah'];
			}
			$this->Journal->save($data);
			$this->redirect(array('controller'=>'Journals', 'action'=>'index'));
		} else {
			$data=$this->Journal->read();
			$account=$this->Account->find('first',array('conditions'=>array('Account.nama'=>$data['Journal']['akun'])));
			if ($account['Account']['tipe']=='Debit') {
				$data['Journal']['jumlah']=$data['Journal']['debit'];
			} else {
				$data['Journal']['jumlah']=$data['Journal']['kredit'];
			}
			$this->data=$data;
		}
		$this->set('id',$id);		        
		$this->set('accounts',$this->Account->find('all'));		        
	}

	public function delete($id=null){
		$this->Journal->delete($id);
		$this->redirect(array('controller'=>'Journals', 'action'=>'index'));
	}

}
?>