<?php
/**
* 
*/
class RentsController extends AppController{
	var $name = 'Rents';
	var $helpers = array('Html', 'Form');
	var $uses = array('Rent','Customer');
	var $layout = 'mainlayout';

	public function beforeFilter(){
		parent::beforeFilter();
	}

	public function ubahhasil($masukan) {
			$tanggal=strtotime($masukan);
			$hari=intval(date("d",$tanggal)); 
			switch (date("m",$tanggal)) {
				case "01" : $text = "Januari"; break;
				case "02" : $text = "Februari"; break;
				case "03" : $text = "Maret"; break;
				case "04" : $text = "April"; break;
				case "05" : $text = "Mei"; break;
				case "06" : $text = "Juni"; break;
				case "07" : $text = "Juli"; break;
				case "08" : $text = "Agustus"; break;
				case "09" : $text = "September"; break;
				case "10" : $text = "Oktober"; break;
				case "11" : $text = "November"; break;
				case "12" : $text = "Desember"; break;
				default : break;
			}
			$tahun=date("Y",$tanggal);
			return $hari.' '.$text.' '.$tahun;
	}

	public function earlierdate($date1, $date2) {
		$yeardate1=intval(substr($date1,0,4));
		$monthdate1=intval(substr($date1,5,2));
		$daydate1=intval(substr($date1,8,2));
		$yeardate2=intval(substr($date2,0,4));
		$monthdate2=intval(substr($date2,5,2));
		$daydate2=intval(substr($date2,8,2));
		if ($yeardate1<$yeardate2) {
			return true;
		} else if ($yeardate1>$yeardate2) {
			return false;
		} else {
			if ($monthdate1<$monthdate2) {
				return true;
			} else if ($monthdate1>$monthdate2) {
				return false;
			} else {
				if ($daydate1<=$daydate2) {
					return true;
				} else if ($daydate1>$daydate2) {
					return false;
				}
			}
		}
	}
	
	public function find(){
		$this->autoRender=false;
		if (isset($_POST['telepon'])) {
			$telepon=$_POST['telepon'];
			$customer=$this->Customer->find('first',array('conditions' => array('Customer.telepon' => $telepon)));
			if ($customer) {
				echo "berhasil,".$customer['Customer']['nama'].",".$customer['Customer']['alamat'].",".$customer['Customer']['email'];
			} else {
				echo "gagal";
			}
		}
	}

	public function index(){
		if (isset($_GET['halaman'])) {$halaman=$_GET['halaman'];} else {$halaman=0;}
		if (isset($_GET['tgl_awal'])) {$tglawal=$_GET['tgl_awal'];} else {$tglawal=null;}
		if (isset($_GET['tgl_akhir'])) {$tglakhir=$_GET['tgl_akhir'];} else {$tglakhir=null;}
		if (isset($_GET['search'])) {$search=$_GET['search'];} else {$search=null;}
		$data=$this->Rent->find('all');
		$sumber=array();
		$rents=array();
		if (($tglawal==null)&&($tglakhir==null)&&($search==null)) {
			$sumber=$data;
		} else {
			$y=0;
			foreach ($data as $record) {
				$tanggal=$record['Rent']['date'];
				$kondisi1=$this->earlierdate($tglawal,$tanggal)||($tglawal==null);
				$kondisi2=$this->earlierdate($tanggal,$tglakhir)||($tglakhir==null);
				$text=false;
				if ($search) {
					$kondisi3=(strpos(' '.strtoupper($this->ubahhasil($record['Rent']['date'])),strtoupper($search))>0); 
					$kondisi4=(strpos(' '.strtoupper($record['Rent']['nama']),strtoupper($search))>0);
					$kondisi5=(strpos(' '.strtoupper($record['Rent']['plat_mobil']),strtoupper($search))>0);
					$kondisi6=(strpos(' '.strtoupper($record['Rent']['no_invoice']),strtoupper($search))>0);
					if ($kondisi3||$kondisi4||$kondisi5||$kondisi6) {
						$text=true;
					}
				} else $text=true;
				if ($kondisi1&&$kondisi2&&$text) {
					$sumber[$y]=$record;
					$y++;
				}
			}
		}
		$jumlahsumber=count($sumber);
		$jumlahhalaman=ceil(count($sumber)/10);
		if ($jumlahhalaman==0) {
			$jumlahhalaman=1;
		}
		if ($halaman==0) {
			$halaman=$jumlahhalaman;
		}
		for ($x=0; $x<10; $x++) {
			$indeks=($halaman-1)*10+$x;
			if ($indeks<$jumlahsumber) {
				$rents[$x]=$sumber[$indeks];
			} else break;
		}
		foreach ($rents as $id=>$rent) {
			$rents[$id]['Rent']['date']=$this->ubahhasil($rents[$id]['Rent']['date']);
		}
		$this->set('rents',$rents);		        
		$this->set('jumlahdata',count($sumber));		        
		$this->set('halaman',$halaman);		        
		$this->set('jumlahhalaman',$jumlahhalaman);		        
		$this->set('tglawal',$tglawal);		        
		$this->set('tglakhir',$tglakhir);		        
		$this->set('search',$search);		        
		$this->set('customers',$this->Customer->find('all'));		        
	}

	public function add(){
		if(!empty($this->data)){
			$data=$this->data;
			$data['Rent']['date']=date("Y-m-d");
			$data['Rent']['username']=$this->Auth->user('username');
			$data['Rent']['cabang']=$this->Auth->user('cabang_id');
			$this->Rent->save($data);
			$this->redirect(array('controller'=>'Rents', 'action'=>'index'));
		}
	}

	public function edit($id=null){
		$this->Rent->id=$id;
		if(!empty($this->data)){
			$data=$this->data;
			$this->Rent->save($data);
			$this->redirect(array('controller'=>'Rents', 'action'=>'index'));
		} else {
			$this->data=$this->Rent->read();
		}
		$this->set('id',$id);		        
	}

	public function delete($id=null){
		$this->Rent->delete($id);
		$this->redirect(array('controller'=>'Rents', 'action'=>'index'));
	}

	public function report(){
		
	}

}
?>