<?php
/**
* 
*/
class TicketsController extends AppController{
	var $name = 'Tickets';
	var $helpers = array('Html', 'Form');
	var $uses = array('Transaction','Ticket','Customer','Cabang','Master');
	var $layout = 'mainlayout';

	public function beforeFilter(){
		parent::beforeFilter();
	}

	public function index(){
		$listcabang = $this->Cabang->find('list', array(
			'fields'=>array('Cabang.nama'),
			'order'=>array('Cabang.id')
			)
		);
		$this->set('listcabang', $listcabang);
		$today = $this->balik(date('Y-m-d'));
		$tanggal = $today;
		if (isset($this->data['Ticket']['tanggal'])) {
			$tanggal=$this->data['Ticket']['tanggal'];
		}
		$combocabang=null;
		if (isset($this->data['Ticket']['combocabang'])) {
			$combocabang=$this->data['Ticket']['combocabang'];
		}
		$search=null;		
		if (isset($this->data['Ticket']['search'])) {
			$search=$this->data['Ticket']['search'];
		}
			$data = $this->Ticket->find('all', array(
				'conditions'=>array('Ticket.date'=>$tanggal),
				'order'=>array('Ticket.id')
				)
			);
		$sumber=array();
		$y=0;
		foreach ($data as $record) {
			$cabang_id=$record['Transaction']['cabang_id'];
			$cabang=$this->Cabang->find('first',array('conditions'=>array('Cabang.id'=>$cabang_id)));
			$record['Ticket']['cabang']=$cabang['Cabang']['nama'];
			$kondisi1=($cabang_id==$combocabang)||($combocabang==null);
			if ($search==null) {
				$kondisi2=true;
			} else {
				$kondisi3=(strpos(' '.strtoupper($record['Transaction']['nama']),strtoupper($search))>0);
				$kondisi4=(strpos(' '.strtoupper($record['Ticket']['maskapai']),strtoupper($search))>0);
				$kondisi5=(strpos(' '.strtoupper($record['Ticket']['kode_booking']),strtoupper($search))>0);
				$kondisi6=(strpos(' '.strtoupper($record['Transaction']['no_invoice']),strtoupper($search))>0);
				if ($kondisi3||$kondisi4||$kondisi5||$kondisi6) {
					$kondisi2=true;
				} else {
					$kondisi2=false;
				}
			}
			if ($kondisi1&&$kondisi2) {
				$sumber[$y]=$record;
				$y++;
			}
		}
		$this->set('tickets',$sumber);		        
		$this->set('jumlahdata',count($sumber));		        
		$this->set('today',$today);		        
		$this->set('tanggal',$tanggal);		        
		$this->set('cabang',$combocabang);		        
		$this->set('search',$search);		        
	}

	public function invoice($id=null) {
		if ($id==null) {
			$ada=false;
			$tickets=array();
			$invoice=null;
		} else {
			$ada=true;
		$this->Transaction->id=$id;
		$transaksi=$this->Transaction->read();
		$tickets = $this->Ticket->find('all', array('conditions'=>array('Ticket.transaction_id'=>$id)));
		$subtotal=0;
		foreach ($tickets as $no=>$ticket) {
			$tickets[$no]['Ticket']['unit_price']=$this->rupiah($ticket['Ticket']['unit_price']);
			$tickets[$no]['Ticket']['total_price']=$this->rupiah($ticket['Ticket']['total_price']);
			$subtotal+=floatval($ticket['Ticket']['total_price']);
		}
		$transaksi['Transaction']['sisa']=$this->rupiah(floatval($transaksi['Transaction']['total'])-floatval($transaksi['Transaction']['bayar']));
		$transaksi['Transaction']['subtotal']=$this->rupiah($subtotal);
		$transaksi['Transaction']['administrasi']=$this->rupiah($transaksi['Transaction']['administrasi']);
		$transaksi['Transaction']['disc']=$this->rupiah($transaksi['Transaction']['disc']);
		$transaksi['Transaction']['netto']=$this->rupiah($transaksi['Transaction']['netto']);
		$transaksi['Transaction']['add_charge']=$this->rupiah($transaksi['Transaction']['add_charge']);
		$transaksi['Transaction']['total']=$this->rupiah($transaksi['Transaction']['total']);
		$transaksi['Transaction']['bayar']=$this->rupiah($transaksi['Transaction']['bayar']);
		$invoice=$transaksi['Transaction']['no_invoice'];
		$this->set('transaksi', $transaksi);
		}
		$this->set('invoice', $invoice);
		$this->set('tickets', $tickets);
		$this->set('count', count($tickets));
		$this->set('id', $id);
		$this->set('tanggal', $this->balik(date("Y-m-d")));
		$this->set('ada', $ada);
	}
	public function find(){
		$this->autoRender=false;
		if (isset($_POST['telepon'])) {
			$telepon=$_POST['telepon'];
			$customer=$this->Customer->find('first',array('conditions' => array('Customer.telepon' => $telepon)));
			if ($customer) {
				echo "berhasil,".$customer['Customer']['nama'].",".$customer['Customer']['alamat'].",".$customer['Customer']['email'];
			} else {
				echo "gagal";
			}
		}
	}

	public function findinvoice(){
		$this->autoRender=false;
		if (isset($_POST['invoice'])) {
			$invoice=$_POST['invoice'];
			$transaction=$this->Transaction->find('first',array('conditions' => array('Transaction.no_invoice' => $invoice)));
			if ($transaction) {
				echo "berhasil,".Router::url(array('controller'=>'Tickets', 'action'=>'invoice', $transaction['Transaction']['id']));
			} else {
				echo "gagal";
			}
		}
	}

	public function search(){
		$kriteria[0]="Nama Pelanggan";
		$kriteria[1]="Telepon Pelanggan";
		$kriteria[2]="Alamat Pelanggan";
		$kriteria[3]="Email Pelanggan";
		$kriteria[4]="Maskapai";
		$kriteria[5]="Rute";
		$kriteria[6]="Kelas";
		$kriteria[7]="Tanggal Terbang";
		$kriteria[8]="Jam Terbang";
		$kriteria[9]="Konfirmasi Oleh";
		$kriteria[10]="Cara Bayar";
		$kriteria[11]="Kartu Kredit";
		$kriteria[12]="Status";
		$kriteria[13]="Pembayaran";
		$kriteria[14]="Kode Booking";
		$kriteria[15]="No Invoice";
		$kriteria[16]="Cabang";
		$this->set('kriteria', $kriteria);
		$listcabang = $this->Cabang->find('list', array(
			'fields'=>array('Cabang.id', 'Cabang.nama'),
			'order'=>array('id')
			)
		);
		$this->set('listcabang', $listcabang);
		$listcarabayar = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Cara Bayar'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('listcarabayar', $listcarabayar);
		$listkartu = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Kartu Kredit'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('listkartu', $listkartu);
		$liststatus = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Status Transaksi'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('liststatus', $liststatus);
		$listbayar[0]="Sudah Lunas";
		$listbayar[1]="Belum Lunas";
		$this->set('listbayar', $listbayar);
		$tanggalawal = null;
		if (isset($this->data['tanggalawal'])) {
			$tanggalawal=$this->data['tanggalawal'];
		}
		$tanggalakhir = null;
		if (isset($this->data['tanggalakhir'])) {
			$tanggalakhir=$this->data['tanggalakhir'];
		}
		$tiadadata=true;
		if (isset($this->data['combokriteria'])) {
			$tiadadata=false;
			$jumlahkriteria=count($this->data['combokriteria']);
			$this->set('isidata',$this->data);		        
			$this->set('jumlahkriteria',$jumlahkriteria);		        
		}
		$this->set('tiadadata',$tiadadata);		        
		$halaman=1;		
		if (isset($this->data['combohalaman'])) {
			$halaman=$this->data['combohalaman'];
		}
		$data = $this->Ticket->find('all');
		$sumber=array();
		$tickets=array();
		$y=0;
		foreach ($data as $record) {
			$ubahtanggal=$this->ubah($record['Ticket']['date']);
				$kondisi1=true;
				if ($tanggalawal) {
					$ubahtanggalawal=$this->ubah($tanggalawal);
					$kondisi1=$this->earlierdate($ubahtanggalawal,$ubahtanggal);
				}
				$kondisi2=true;
				if ($tanggalakhir) {
					$ubahtanggalakhir=$this->ubah($tanggalakhir);
					$kondisi2=$this->earlierdate($ubahtanggal,$ubahtanggalakhir);
				}
			$cabang_id=$record['Transaction']['cabang_id'];
			$cabang=$this->Cabang->find('first',array('conditions'=>array('Cabang.id'=>$cabang_id)));
			$record['Ticket']['cabang']=$cabang['Cabang']['nama'];
			$kondisi3=true;
			$kondisi=array();
			$adadata=false;
			if (isset($this->data['combokriteria'])) {
				for ($i=0; $i < $jumlahkriteria; $i++) { 
					switch ($this->data['combokriteria'][$i]) {
						case "Cabang" : 
							$kondisi[$i]=($record['Ticket']['cabang']==$this->data['combocabang'][$i])||("Semua"==$this->data['combocabang'][$i]); 
						break;
						case "Nama Pelanggan" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Transaction']['nama']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Telepon Pelanggan" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Transaction']['telepon']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Alamat Pelanggan" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Transaction']['alamat']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Email Pelanggan" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Transaction']['email']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Maskapai" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['maskapai']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Rute" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['rute']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Kelas" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['kelas']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Tanggal Terbang" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['date_line']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Jam Terbang" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['jam_terbang']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Konfirmasi Oleh" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['confirmed_by']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "Cara Bayar" :
							$kondisi[$i]=$record['Transaction']['cara_bayar']==$this->data['combocarabayar'][$i]; 
						break;
						case "Kartu Kredit" :
							$kondisi[$i]=$record['Transaction']['kartu_kredit']==$this->data['combokartukredit'][$i]; 
						break;
						case "Status" :
							$kondisi[$i]=$record['Transaction']['status']==$this->data['combostatus'][$i]; 
						break;
						case "Pembayaran" :
							$datatotal=floatval($record['Transaction']['total']);
							$databayar=floatval($record['Transaction']['bayar']);
							if ($databayar>=$datatotal) {$lunas="Sudah Lunas";} else {$lunas="Belum Lunas";}
							$kondisi[$i]=$lunas==$this->data['combobayar'][$i]; 
						break;
						case "Kode Booking" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Ticket']['kode_booking']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
						case "No Invoice" :
							if ($this->data['search'][$i]) {
								$kondisi[$i]=(strpos(' '.strtoupper($record['Transaction']['no_invoice']),strtoupper($this->data['search'][$i]))>0); 
							} else {
								$kondisi[$i]=true;
							}
						break;
					}
					$kondisi3=$kondisi3&&$kondisi[$i];
				}
			} else {
				$kondisi3=true;
			}
			if ($kondisi1&&$kondisi2&&$kondisi3) {
				$sumber[$y]=$record;
				$y++;
			}
		}
		$jumlahsumber=count($sumber);
		$jumlahhalaman=ceil(count($sumber)/10);
		if ($jumlahhalaman==0) {
			$jumlahhalaman=1;
		}
		if ($halaman>$jumlahhalaman) $halaman=$jumlahhalaman;
		for ($x=0; $x<10; $x++) {
			$indeks=($halaman-1)*10+$x;
			if ($indeks<$jumlahsumber) {
				$tickets[$x]=$sumber[$indeks];
			} else break;
		}		
		$this->set('tickets',$tickets);		        
		$this->set('jumlahdata',count($sumber));		        
		$this->set('halaman',$halaman);		        
		$this->set('jumlahhalaman',$jumlahhalaman);		        
		$this->set('tanggalawal',$tanggalawal);		        
		$this->set('tanggalakhir',$tanggalakhir);		        
	}

	private function getnoinvoice(){
		$urutan = '1';
		$noinvoice = $this->Transaction->find('first', array(
			'conditions'=>array('Transaction.cabang_id'=>$this->Auth->user('cabang_id')),
			'order' => array('Transaction.no_invoice DESC')));
		$cabang = $this->Cabang->find('first', array(
			'conditions'=>array('Cabang.id'=>$this->Auth->user('cabang_id'))));
			
		if	($noinvoice) {
			$urutan = intval(substr($noinvoice['Transaction']['no_invoice'], 2, 4))+1;
		}
		switch (strlen($urutan)) {
			case 1:
				$nomer = $cabang['Cabang']['kode'].'000'.$urutan;
				break;
			case 2:
				$nomer = $cabang['Cabang']['kode'].'00'.$urutan;
				break;
			case 3:
				$nomer = $cabang['Cabang']['kode'].'0'.$urutan;
				break;
			default:
				$nomer = $cabang['Cabang']['kode'].''.$urutan;
				break;
		}
		return $nomer;
	}

	public function add(){
		$today = $this->balik(date('Y-m-d'));
		$this->set('today',$today);		        
		$listcarabayar = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Cara Bayar'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('listcarabayar', $listcarabayar);
		$listkartu = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Kartu Kredit'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('listkartu', $listkartu);
		$liststatus = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Status Transaksi'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('liststatus', $liststatus);
		if(!empty($this->data)){
			$data=$this->data;
			$data['Transaction']['cabang_id'] = $this->Auth->user('cabang_id');
			$data['Transaction']['tipe_transaksi'] = 'Tiket';
			$data['Transaction']['tanggal'] = $this->balik(date('Y-m-d'));
			$data['Transaction']['no_invoice'] = $this->getnoinvoice();
			$data['Transaction']['created_at'] = $this->balik(date('Y-m-d H:i:s'));
			$data['Transaction']['updated_at'] = $this->balik(date('Y-m-d H:i:s'));
			$data['Transaction']['updated_by'] = $this->Auth->user('nama');
			$transaction=$this->Transaction->save($data);
				for ($i=0; $i < count($data['date']) ; $i++) { 
					$tiket['Ticket']['transaction_id'] = $transaction['Transaction']['id'];
					$tiket['Ticket']['kode_booking'] = $data['kode_booking'][$i];
					$tiket['Ticket']['date'] = $data['date'][$i];
					$tiket['Ticket']['date_line'] = $data['date_line'][$i];
					$tiket['Ticket']['confirmed_by'] = $data['confirmed_by'][$i];
					$tiket['Ticket']['maskapai'] = $data['maskapai'][$i];
					$tiket['Ticket']['rute'] = $data['rute'][$i];
					$tiket['Ticket']['kelas'] = $data['kelas'][$i];
					$tiket['Ticket']['jam_terbang'] = $data['jam_terbang'][$i];
					$tiket['Ticket']['qtt'] = $data['qtt'][$i];
					$tiket['Ticket']['unit_price'] = $data['hargasatuan'][$i];
					$tiket['Ticket']['total_price'] = $data['hargatotal'][$i];
					$arrTiket[]=$tiket;
				}
				$this->Ticket->saveAll($arrTiket);
				if ($data['Transaction']['telepon']) {
					$userexist = $this->Customer->find('first', array('conditions'=>array('Customer.telepon'=>$data['Transaction']['telepon'])));
					if(empty($userexist)){
						$cust['Customer']['nama'] = $data['Transaction']['nama'];
						$cust['Customer']['telepon'] = $data['Transaction']['telepon'];
						$cust['Customer']['alamat'] = $data['Transaction']['alamat'];
						$cust['Customer']['email'] = $data['Transaction']['email'];
						$this->Customer->save($cust);
					}
				}
			$this->redirect(array('controller'=>'Tickets', 'action'=>'invoice', $transaction['Transaction']['id']));
		}
	}

	public function edit($id=null){
		$this->Transaction->id=$id;
		$transaksi=$this->Transaction->read();
		$tickets = $this->Ticket->find('all', array('conditions'=>array('Ticket.transaction_id'=>$id)));
		$today = $this->balik(date('Y-m-d'));
		$this->set('today', $today);
		$this->set('transaksi', $transaksi);
		$this->set('invoice', $transaksi['Transaction']['no_invoice']);
		$this->set('count', count($tickets));
		$this->set('id', $id);
		$listcarabayar = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Cara Bayar'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('listcarabayar', $listcarabayar);
		$listkartu = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Kartu Kredit'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('listkartu', $listkartu);
		$liststatus = $this->Master->find('list', array(
			'conditions'=>array('group'=> 'Status Transaksi'),
			'fields'=>array('kode', 'kode'),
			'order'=>array('id')
			)
		);
		$this->set('liststatus', $liststatus);
		if(!empty($this->data)){
			$data=$this->data;
			$data['Transaction']['updated_at'] = $this->balik(date('Y-m-d H:i:s'));
			$data['Transaction']['updated_by'] = $this->Auth->user('nama');
			$this->Transaction->save($data);
			$this->Ticket->deleteAll(array('Ticket.transaction_id'=>$id));
				for ($i=0; $i < count($data['date']) ; $i++) { 
					$tiket['Ticket']['transaction_id'] = $id;
					$tiket['Ticket']['kode_booking'] = $data['kode_booking'][$i];
					$tiket['Ticket']['date'] = $data['date'][$i];
					$tiket['Ticket']['date_line'] = $data['date_line'][$i];
					$tiket['Ticket']['confirmed_by'] = $data['confirmed_by'][$i];
					$tiket['Ticket']['maskapai'] = $data['maskapai'][$i];
					$tiket['Ticket']['rute'] = $data['rute'][$i];
					$tiket['Ticket']['kelas'] = $data['kelas'][$i];
					$tiket['Ticket']['jam_terbang'] = $data['jam_terbang'][$i];
					$tiket['Ticket']['qtt'] = $data['qtt'][$i];
					$tiket['Ticket']['unit_price'] = $data['hargasatuan'][$i];
					$tiket['Ticket']['total_price'] = $data['hargatotal'][$i];
					$arrTiket[]=$tiket;
				}
				$this->Ticket->saveAll($arrTiket);
			$this->redirect(array('controller'=>'Tickets', 'action'=>'invoice', $id));
		}
	}

	public function delete($id=null){
		$this->Transaction->delete($id);
		$this->Ticket->deleteAll(array('Ticket.transaction_id'=>$id));
		$this->redirect(array('controller'=>'Tickets', 'action'=>'search'));
	}

	public function dashboard(){
		
	}

	public function report(){
		
	}

}
?>